var Iport = function()
{
	var iport = {};
	var debug = 0;
	
	var REPORT_TYPE_IMPORT = 'import';
	var REPORT_TYPE_IMPORT_OUTPUT_CSV = 'import_output_csv';
	var importFilesAreValid = false;
	var importFileStructuresAreValid = false;
	var jsonIncaData = {};

	iport.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', iport.validateStep1);
		Events.addEventHandler('importfile', 'change', iport.importFileOnChange);
		Buttons.addClickHandler('gonext', iport.checkImportFile);
		Buttons.addClickHandler('simplecheck', iport.simpleCheckOfImportFile);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('goimport', Wizard.goRegister);
		Buttons.addClickHandler('downloadreportfile', iport.downloadReportFile);
		Buttons.addClickHandler('downloadoutputcsvfile', iport.downloadOutputCsvFile);
		Buttons.addClickHandler('deleteoutputcsvfile', iport.deleteOutputCsvFile);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', iport.submit);

		// Initialize INCA export date to current date
		var frm = document.forms['reggie'];
		frm.exportDate.value = Dates.formatDate(new Date(), 'yyyyMMdd');
		
		Doc.show('step-1');
		Doc.show('gonext');
		Doc.addClass('gonext', 'disabled');
		Doc.show('simplecheck');
		Doc.addClass('simplecheck', 'disabled');
		Doc.hide('goimport');
		Doc.addClass('goimport', 'disabled');
		iport.checkForReportFiles();
	}
	
	iport.validateStep1 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('importfile');
		if (!valid) event.preventDefault();
	}

	iport.importFileOnChange = function()
	{
		var frm = document.forms['reggie'];
		var files = frm.importfile.files;

		if (files != null)
		{
			Doc.removeClass('gonext', 'disabled');
			Doc.removeClass('simplecheck', 'disabled');
			Doc.removeClass('goimport', 'disabled');
		}
		else
		{
			Doc.addClass('gonext', 'disabled');
			Doc.addClass('simplecheck', 'disabled');
			Doc.addClass('goimport', 'disabled');
		}
	}

	iport.importFileLoaded = function(event)
	{
		Doc.removeClass('gonext', 'disabled');
		Doc.removeClass('simplecheck', 'disabled');
		Doc.removeClass('goimport', 'disabled');
	}

	iport.simpleCheckOfImportFile = function()
	{
		var frm = document.forms['reggie'];
		var exportDate = frm.exportDate.value;

		Doc.addClass('gonext', 'disabled');
		Doc.addClass('simplecheck', 'disabled');

		var formData = new FormData();
		var files = frm.importfile.files;
		for (var i = 0; i < files.length; i++)
		{
			var file = files[i];
			formData.append('incafiles[]', file, file.name);
		}

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportInca';
		url += '&exportdate='+encodeURIComponent(exportDate);
		url += '&importcheckonly=true';
		url += '&simplecheckonly=true';

		// POST
		Wizard.showLoadingAnimation('Checking INCA data...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.initializeStep2, 'POST', formData);
	}

	iport.checkImportFile = function()
	{
		var frm = document.forms['reggie'];
		var exportDate = frm.exportDate.value;

		Doc.addClass('gonext', 'disabled');
		Doc.addClass('simplecheck', 'disabled');

		var formData = new FormData();
		var files = frm.importfile.files;
		for (var i = 0; i < files.length; i++)
		{
			var file = files[i];
			formData.append('incafiles[]', file, file.name);
		}

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportInca';
		url += '&exportdate='+encodeURIComponent(exportDate);
		url += '&importcheckonly=true';

		// POST
		Wizard.showLoadingAnimation('Checking INCA data...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.initializeStep2, 'POST', formData);
	}

	iport.initializeStep2 = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(2);

		// Get INCA file properties from JSON data
		
		// INCA file properties - basic check
		var fileProp = response.incaFileProperties;
		var simpleCheckOnly = response.simpleCheckOnly;

		// Print name of file
		var filelisttext = '';
		var tmpFilename = fileProp.filename;
		filelisttext += '<b>&nbsp;File:&nbsp;' + tmpFilename + '</b><br>';
		Doc.element('incafilenames').innerHTML = filelisttext;

		//
		// INCA file properties - Basic check
		//
		var basicchecktabletext = '<table class="incafileproptable">';

		// Table header
		basicchecktabletext += iport.createTableHeader();

		// # Header columns
		var numHeaderColumnsOk = iport.fetchTableRowStatus(fileProp, 'numHeaderColumns', 'lt', 3);
		basicchecktabletext += iport.createTableRow(fileProp, '# Header columns', 'numHeaderColumns', numHeaderColumnsOk, 'error', '&#8805; 3 allowed');

		// # Lines of data
		var numLinesOk = iport.fetchTableRowStatus(fileProp, 'numLines', 'lt', 1);
		basicchecktabletext += iport.createTableRow(fileProp, '# Lines of data', 'numLines', numLinesOk, 'error', '');

		// # Lines with internal line feeds
		var numLinesWithLineFeedsOk = iport.fetchTableRowStatus(fileProp, 'numLinesWithLineFeeds', 'gt', 0);
		basicchecktabletext += iport.createTableRow(fileProp, '# Lines with internal line feeds', 'numLinesWithLineFeeds', numLinesWithLineFeedsOk, 'warning', '');

		// # Lines with too many columns
		var numLinesWithTooManyColumnsOk = iport.fetchTableRowStatus(fileProp, 'numLinesWithTooManyColumns', 'gt', 0);
		basicchecktabletext += iport.createTableRow(fileProp, '# Lines with too many columns', 'numLinesWithTooManyColumns', numLinesWithTooManyColumnsOk, 'error', '0 allowed');

		// # Lines with too few columns
		var numLinesWithTooFewColumnsOk = iport.fetchTableRowStatus(fileProp, 'numLinesWithTooFewColumns', 'gt', 0);
		basicchecktabletext += iport.createTableRow(fileProp, '# Lines with too few columns', 'numLinesWithTooFewColumns', numLinesWithTooFewColumnsOk, 'error', '0 allowed');

		//
		basicchecktabletext += '</table>';
		Doc.element('incaFilePropBasicCheckTable').innerHTML = basicchecktabletext;

		//
		// INCA file properties - Internal data check
		//
		var internalchecktabletext = '<table class="incafileproptable">';

		// Table header
		internalchecktabletext += iport.createTableHeader();

		// # Duplicate header columns
		var numHeaderDuplicatesOk = iport.fetchTableRowStatus(fileProp, 'numHeaderDuplicates', 'gt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, '# Duplicate header columns', 'numHeaderDuplicates', numHeaderDuplicatesOk, 'error', '0 allowed');

		// Temporary patient ID column index
		var tempPatIdClmIndexOk = iport.fetchTableRowStatus(fileProp, 'tempPatIdClmIndex', 'lt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, 'Temporary patient ID column index', 'tempPatIdClmIndex', tempPatIdClmIndexOk, 'error', '&#8805; 0 allowed');

		// Personal number column index
		var personalNoClmIndexOk = iport.fetchTableRowStatus(fileProp, 'personalNoClmIndex', 'lt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, 'Personal number column index', 'personalNoClmIndex', personalNoClmIndexOk, 'error', '&#8805; 0 allowed');

		// Laterality description column index
		var lateralityDescriptionClmIndexOk = iport.fetchTableRowStatus(fileProp, 'lateralityDescriptionClmIndex', 'lt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, 'Laterality description column index', 'lateralityDescriptionClmIndex', lateralityDescriptionClmIndexOk, 'error', '&#8805; 0 allowed');

		// # Unknown headers
		var numUnknownHeadersOk = iport.fetchTableRowStatus(fileProp, 'numUnknownHeaders', 'gt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, '# Unknown headers', 'numUnknownHeaders', numUnknownHeadersOk, 'warning', 'Columns skipped');

		// # Data lines with personal no.
		var numPersonalNoLinesOk = iport.fetchTableRowStatus(fileProp, 'numPersonalNoLines', 'eq', 0);
		internalchecktabletext += iport.createTableRow(fileProp, '# Data lines with personal no.', 'numPersonalNoLines', numPersonalNoLinesOk, 'error', 'Required for import');

		// # Personal no. with more than 2 lines
		var numPersonalNoWithMoreThanTwoLinesOk = iport.fetchTableRowStatus(fileProp, 'numPersonalNoWithMoreThanTwoLines', 'gt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, '# Personal no. with more than 2 lines', 'numPersonalNoWithMoreThanTwoLines', numPersonalNoWithMoreThanTwoLinesOk, 'warning', 'Data lines skipped');

		// # Personal no.s with many identical lateralities
		var numPersonalNoWithManyIdenticalLateralityLinesOk = iport.fetchTableRowStatus(fileProp, 'numPersonalNoWithManyIdenticalLateralityLines', 'gt', 0);
		internalchecktabletext += iport.createTableRow(fileProp, '# Personal no.s with many identical lateralities', 'numPersonalNoWithManyIdenticalLateralityLines', numPersonalNoWithManyIdenticalLateralityLinesOk, 'warning', 'Data lines skipped');

		//
		internalchecktabletext += '</table>';
		Doc.element('incaFilePropInternalDataCheckTable').innerHTML = internalchecktabletext;

		if (numHeaderColumnsOk &&
			numLinesOk &&
			numLinesWithTooManyColumnsOk &&
			numLinesWithTooFewColumnsOk &&
			numHeaderDuplicatesOk &&
			tempPatIdClmIndexOk &&
			personalNoClmIndexOk &&
			lateralityDescriptionClmIndexOk &&
			numPersonalNoLinesOk)
		{
			importFileStructuresAreValid = true;
		}

		//
		// INCA file properties - Database consistency check
		//
		if (!simpleCheckOnly)
		{
			var consistencychecktabletext = '<table class="incafileproptable">';

			// Table header
			consistencychecktabletext += iport.createTableHeader();

			// # Data lines with personal no. not in database
			var numDataLinesWithoutDatabaseReferenceOk = iport.fetchTableRowStatus(fileProp, 'numDataLinesWithoutDatabaseReference', 'gt', 0);
			consistencychecktabletext += iport.createTableRow(fileProp, '# Data lines with personal no. not in database', 'numDataLinesWithoutDatabaseReference', numDataLinesWithoutDatabaseReferenceOk, 'warning', 'Data lines skipped');

			// # Patient lateralities without database reference
			var numPatientLateralitiesWithoutDatabaseReferenceOk = iport.fetchTableRowStatus(fileProp, 'numPatientLateralitiesWithoutDatabaseReference', 'gt', 0);
			consistencychecktabletext += iport.createTableRow(fileProp, '# Patient lateralities without database reference', 'numPatientLateralitiesWithoutDatabaseReference', numPatientLateralitiesWithoutDatabaseReferenceOk, 'warning', 'Data lines skipped');

			// # Data lines with bad values
			var numBadValueLinesOk = iport.fetchTableRowStatus(fileProp, 'numBadValueLines', 'gt', 0);
			consistencychecktabletext += iport.createTableRow(fileProp, '# Data lines with bad values', 'numBadValueLines', numBadValueLinesOk, 'warning', 'Data lines skipped');

			//
			consistencychecktabletext += '</table>';
			Doc.element('incaFilePropDatabaseConsistencyCheckTable').innerHTML = consistencychecktabletext;
		}
		else
		{
			var consistencychecktabletext = '&nbsp;(Not included in simple file check)';
			Doc.element('incaFilePropDatabaseConsistencyCheckTable').innerHTML = consistencychecktabletext;
		}

		//
		// INCA file properties - Database consistency check II
		//
		var consistencycheck2tabletext = '<table class="incafileproptable">';

		// Table header
		consistencycheck2tabletext += '<tr>';
		consistencycheck2tabletext += '<th class="propertycolumn">Property</th>';
		consistencycheck2tabletext += '<th class="valuecolumn">Value</th>';
		consistencycheck2tabletext += '<th class="statuscolumn">Status</th>';
		consistencycheck2tabletext += '<th>Comment</th>';
		consistencycheck2tabletext += '</tr>';

		// # Missing INCA headers
		consistencycheck2tabletext += '<tr>';
		consistencycheck2tabletext += '<td class="propertycolumn"># Missing INCA headers</td>';
		var numMissingIncaHeadersOk = true;
		var numMissingIncaHeaders = response.numMissingIncaHeaders;
		consistencycheck2tabletext += '<td class="valuecolumn">' + numMissingIncaHeaders + '</td>';
		if (numMissingIncaHeaders > 0)
		{
			numMissingIncaHeadersOk = false;
		}
		var numMissingIncaHeadersStatusTag = iport.fetchValidityIcon(numMissingIncaHeadersOk, 'warning');
		consistencycheck2tabletext += '<td class="statuscolumn">' + numMissingIncaHeadersStatusTag + '</td>';
		consistencycheck2tabletext += '<td>INCA headers skipped</td>';
		consistencycheck2tabletext += '</tr>';

		//
		consistencycheck2tabletext += '</table>';
		Doc.element('incaFilePropDatabaseConsistencyCheck2Table').innerHTML = consistencycheck2tabletext;

		Doc.show('step-2');

		// Show summary line
		var text = "";
		if (!simpleCheckOnly)
		{
			var numDataLinesForImport = fileProp.numDataLinesForImport;
			numPersonalNoLines = fileProp.numPersonalNoLines;
			text += "&nbsp;# Data lines for import = " + numDataLinesForImport + " of " + numPersonalNoLines + "<br><br>";
		}
		if (!importFileStructuresAreValid)
		{
			text += "<img src=\"../images/error.png\" style=\"padding-left: 1em;\" />&nbsp;Errors were found in INCA file[s]. Fix these and try again.";
		}
		Doc.element('filepropertymessage').innerHTML = text;

		if (importFileStructuresAreValid)
		{
			Wizard.showFinalMessage(response.messages);
		}
		
		if (response.notFound && response.notFound.length)
		{
			Doc.element('not-found').innerHTML = response.notFound.join('<br>');
			Doc.show('not-found');
		}

		Doc.addClass('exportDate', 'disabled');
		Doc.addClass('exportDateCalendar', 'disabled');
		Doc.addClass('importfile', 'disabled');

		if (simpleCheckOnly)
		{
			Doc.show('gonext');
			Doc.removeClass('gonext', 'disabled');
			Doc.hide('goimport');
		}
		else
		{
			Doc.hide('gonext');
			Doc.show('goimport');
		}
		Doc.hide('simplecheck');
		if (!importFileStructuresAreValid)
		{
			Doc.addClass('goimport', 'disabled');
			Doc.show('gorestart');
		}
		iport.checkForReportFiles();
	}

	iport.createTableHeader = function()
	{
		// Table header
		var text = '';
		text += '<tr>';
		text += '<th class="propertycolumn">Property</th>';
		text += '<th class="valuecolumn">Value</th>';
		text += '<th class="statuscolumn">Status</th>';
		text += '<th>Comment</th>';
		text += '</tr>';
		return text;
	}

	iport.fetchTableRowStatus = function(tmpFileProp, clmKey, failOperator, failLimit)
	{
		var valuesOk = true;
		var value = tmpFileProp[clmKey];
		if (failOperator == 'eq')
		{
			if (value == failLimit)
			{
				valuesOk = false;
			}
		}
		else if (failOperator == 'lt')
		{
			if (value < failLimit)
			{
				valuesOk = false;
			}
		}
		else if (failOperator == 'gt')
		{
			if (value > failLimit)
			{
				valuesOk = false;
			}
		}
		return valuesOk;
	}

	iport.createTableRow = function(tmpFileProp, title, clmKey, status, alertType, cmt)
	{
		// Table row
		var text = '';
		text += '<tr>';
		text += '<td class="propertycolumn">' + title + '</td>';
		var value = tmpFileProp[clmKey];
		text += '<td class="valuecolumn">' + value + '</td>';
		var statusTag = iport.fetchValidityIcon(status, alertType);
		text += '<td class="statuscolumn">' + statusTag + '</td>';
		text += '<td>' + cmt + '</td>';
		text += '</tr>';
		return text;
	}

	iport.createTableRow2 = function(tmpFileProp, title, clmKey, failOperator, failLimit, alertType, cmt)
	{
		// Table row
		var text = '';
		text += '<tr>';
		text += '<td class="propertycolumn">' + title + '</td>';
		var valuesOk = true;
		var value = tmpFileProp[clmKey];
		text += '<td class="valuecolumn">' + value + '</td>';
		if (failOperator == 'eq')
		{
			if (value == failLimit)
			{
				valuesOk = false;
			}
		}
		else if (failOperator == 'lt')
		{
			if (value < failLimit)
			{
				valuesOk = false;
			}
		}
		else if (failOperator == 'gt')
		{
			if (value > failLimit)
			{
				valuesOk = false;
			}
		}
		var statusTag = iport.fetchValidityIcon(valuesOk, alertType);
		text += '<td class="statuscolumn">' + statusTag + '</td>';
		text += '<td>' + cmt + '</td>';
		text += '</tr>';
		return text;
	}

	iport.fetchValidityIcon = function(isValid, notificationType)
	{
		var tag = "";
		if (isValid)
		{
			tag = "<img src=\"../images/ok.png\" style=\"padding-left: 1em;\" />";			
		}
		else
		{
			tag = "<img src=\"../images/" + notificationType + ".png\" style=\"padding-left: 1em;\" />";
		}
		return tag;
	}

	iport.addValidityIcon = function(id, isValid, notificationType)
	{
		if (isValid)
		{
			Doc.element(id).innerHTML = "<img src=\"../images/ok.png\" style=\"padding-left: 1em;\" />";			
		}
		else
		{
			Doc.element(id).innerHTML = "<img src=\"../images/" + notificationType + ".png\" style=\"padding-left: 1em;\" />";			
		}
	}

	iport.checkForReportFiles = function()
	{
		var jsonReportTypes = [];
		jsonReportTypes[0] = REPORT_TYPE_IMPORT;
		jsonReportTypes[1] = REPORT_TYPE_IMPORT_OUTPUT_CSV;
		iport.checkForReportFiles2(jsonReportTypes);		
	}

	iport.checkForReportFiles2 = function(reportTypes)
	{
		var frm = document.forms['reggie'];

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=CheckForIncaReportFiles';
		url += '&reporttypes='+reportTypes;
		Wizard.showLoadingAnimation('Checking for report files...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.reportFileButtonsDisplay);
	}

	iport.reportFileButtonsDisplay = function(response)
	{
		var frm = document.forms['reggie'];

		var jsonResult = response.result;
		if (jsonResult != null)
		{
			var reportFileExists = jsonResult[REPORT_TYPE_IMPORT];
			if (reportFileExists != null && reportFileExists)
			{
				Doc.show('downloadreportfile');
				Doc.removeClass('downloadreportfile', 'disabled');
			}
			else
			{
				Doc.hide('downloadreportfile');
				Doc.addClass('downloadreportfile', 'disabled');
			}
		
			reportFileExists = jsonResult[REPORT_TYPE_IMPORT_OUTPUT_CSV];
			if (reportFileExists != null && reportFileExists)
			{
				Doc.show('downloadoutputcsvfile');
				Doc.removeClass('downloadoutputcsvfile', 'disabled');
				Doc.show('deleteoutputcsvfile');
				Doc.removeClass('deleteoutputcsvfile', 'disabled');
			}
			else
			{
				Doc.hide('downloadoutputcsvfile');
				Doc.addClass('downloadoutputcsvfile', 'disabled');
				Doc.hide('deleteoutputcsvfile');
				Doc.addClass('deleteoutputcsvfile', 'disabled');
			}
		}
	}

	iport.downloadReportFile = function()
	{
		var frm = document.forms['reggie'];

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadIncaReportFile';
		url += '&reporttype='+REPORT_TYPE_IMPORT;
		window.open(url);
	}

	iport.downloadOutputCsvFile = function()
	{
		var frm = document.forms['reggie'];

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadIncaReportFile';
		url += '&reporttype='+REPORT_TYPE_IMPORT_OUTPUT_CSV;
		window.open(url);
	}

	iport.deleteOutputCsvFile = function()
	{
		var frm = document.forms['reggie'];

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=DeleteIncaReportFile';
		url += '&reporttype='+REPORT_TYPE_IMPORT_OUTPUT_CSV;

		// POST
		var formData = new FormData();
		Wizard.showLoadingAnimation('Deleting INCA import output CSV file...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.submissionResults, 'POST', formData);
	}

	iport.submit = function()
	{
		var frm = document.forms['reggie'];
		var exportDate = frm.exportDate.value;

		var formData = new FormData();
		var files = frm.importfile.files;
		for (var i = 0; i < files.length; i++)
		{
			var file = files[i];
			formData.append('incafiles[]', file, file.name);
		}

		var url = '../Inca.servlet?ID='+App.getSessionId();
		url += '&cmd=ImportInca';
		url += '&exportdate='+encodeURIComponent(exportDate);

		// POST
		Wizard.showLoadingAnimation('Importing INCA data...', 'inca-import-progress');
		Wizard.asyncJsonRequest(url, iport.submissionResults, 'POST', formData);
	}

	iport.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		if (response.notFound && response.notFound.length)
		{
			Doc.element('not-found').innerHTML = response.notFound.join('<br>');
			Doc.show('not-found');
		}
		Doc.show('gorestart');
		iport.checkForReportFiles();
	}

	return iport;
}();

Doc.onLoad(Iport.initPage);

